#ifndef __NOR_H__
#define __NOR_H__
/*
#ifndef CONFIG_ARCH_PL1029
#error "Prolific PL-1029 platform is missing?!"
#endif
*/
#ifndef rNOR_BASE
#error "No proper base register defined for PL NOR flash"
#endif

/* Prolific NOR flash controller related operations */

#define DMA_START	1
#define DMA_END		2

/* NOR flash controller related */

/* register definitions */
#define PIO_DATA_REG	(rNOR_BASE + 0x00)
#define CONFIG_REG	(rNOR_BASE + 0x04)
#define COM_REG		(rNOR_BASE + 0x08)
#define INTR_S_REG	(rNOR_BASE + 0x0c)
#define NOR_ADDR_REG	(rNOR_BASE + 0x10)
#define CTRL_ST_REG	(rNOR_BASE + 0x14)
#define INTR_M_REG	(rNOR_BASE + 0x18)
#define SOFT_RST_REG	(rNOR_BASE + 0x1c)
#define DMA_S_REG	(rNOR_BASE + 0x20)
#define TIMER_REG	(rNOR_BASE + 0x24)
#define PAD_REG		(rNOR_BASE + 0x28)
#define PPI_PRO_CNT_REG	(rNOR_BASE + 0x2c)
#define ADDR_CFG1	(rNOR_BASE + 0x34)
#define ADDR_CFG2	(rNOR_BASE + 0x38)
#define ADDR_CFG3	(rNOR_BASE + 0x3c)
#define ADDR_CFG4	(rNOR_BASE + 0x40)
#define ADDR_CFG5	(rNOR_BASE + 0x44)
#define DATA_CFG1	(rNOR_BASE + 0x48)
#define DATA_CFG2	(rNOR_BASE + 0x4c)
#define DATA_CFG3	(rNOR_BASE + 0x50)
#define DATA_CFG4	(rNOR_BASE + 0x54)
#define DATA_CFG5	(rNOR_BASE + 0x58)


/* interrupt */
#define NOR_TIMEOUT_INTR_MASK   (1<<3)
#define NOR_CMD_INTR_MASK       (1<<2)
#define NOR_DMA_INTR_MASK       (1<<0)

#define NOR_INTR_MASKALL	(NOR_TIMEOUT_INTR_MASK|NOR_CMD_INTR_MASK|NOR_DMA_INTR_MASK)
#define NOR_INTR_SET_MASK(m)	\
do {				\
	unsigned char mask;	\
	mask = 0x00;		\
	mask |= m;		\
	writeb(mask, INTR_M_REG);\
} while(0)

int pl_nor_polling_intr(int intr_bit, int expected);

#endif
